function F=fun(x)

% Date: 2 March 2015 with their Xmin

global hh nvars o

switch hh
    %F. Herrera, M. Lozano, and D. Molina December 23, 2009
    %=================================================================
    %------- F1: Shifted sphere Function ----------Fmin=-450----Xmin=0
    case 1
        x=x-o;    % Shifted
        a=0;
        for i=1:nvars
            aa=x(i)^2;
            a=aa+a;
        end
        %F=a;           % Sphere function Fmin=0,Xmin=0
        F=a-450;        % Shifted Sphere function
        F=F+450;        % Error
        %==================================================================
        %----- F2: Shifted Schwefel function 2.21----Fmin=-450 ----Xmin=0--
    case 2
        x=x-o;   % Shifted
        a=max(abs(x));
        
        %F=a;           % Schwefel function 2.21 Fmin=0,Xmin=0
        F=a-450;        % Shifted Schwefel function 2.21
        F=F+450;        % Error
        %==================================================================
        %---------F3: Shifted Rosenbrock Function -------Fmin=390----Xmin=1
    case 3
        x=x-o;   % Shifted
        a=0;
        for i=1:nvars-1
            aa=100*(x(i+1)-x(i)^2)^2+(x(i)-1)^2;
            a=aa+a;
        end
        
        %F=a;           % Rosenbrock Function Fmin=0,Xmin=0
        F=a+390;        % Shifted Rosenbrock Function
        F=F-390;        % Error
        %==================================================================
        %-------F4: Shifted Rastigirin Function ------Fmin=-330,Xmin=0-----
    case 4
        x=x-o;   % Shifted
        a=0;
        for i=1:nvars
            aa=x(i)^2+10-10*cos(2*pi*x(i));
            a=aa+a;
        end
        %F=a;        % Rastrigin function Fmin=0,Xmin=0
        F=a-330;     % Shifted Rastrigin function
        F=F+330;     % Error
        %==================================================================
        %------ F5: Shifted Greiwank Function ------------Fmin=-180,Xmin=0
    case 5
        x=x-o;  % Shifted
        c=1;
        for i=1:nvars
            b=cos(x(i)/sqrt(i));
            c=c*b;
        end
        a=0;
        for i=1:nvars
            aa=(1/4000)*x(i)^2;
            a=a+aa;
        end
        %F=a-c+1;    % Greiwank function Fmin=0,Xmin=0
        F=a-c+1-180;    % Shifted Greiwank function
        F=F+180;         % Error
        %==================================================================
        %------- F6: Shifted Ackley Function-----------Fmin=-140,Xmin=0 ---
    case 6
        x=x-o;   % Shifted
        a=0;
        b=0;
        for i=1:nvars
            aa=x(i)^2;
            bb=cos(2*pi*x(i));
            a=aa+a;
            b=bb+b;
        end
        %F=-20*exp(-0.2*sqrt((1/nvars)*a))-exp((1/nvars)*b)+20+exp(1);   % Achley function Fmin=0,Xmin=0
        F=-20*exp(-0.2*sqrt((1/nvars)*a))-exp((1/nvars)*b)+20+exp(1)-140;    % Shifted Ackley function
        F=F+140;   % Error
        %==================================================================
        %-------------F7: Schwefel function 2.22-------Fmin=0----Xmin=0----
    case 7
        b=1;
        a=0;
        for i=1:nvars
            aa=abs(x(i));
            a=aa+a;
            b=b*aa;
        end
        F=a+b;
        %==================================================================
        %-------------F8: Schwefel function 1.2-------Fmin=0--Xmin=0-------
    case 8
        b=0;
        for i=1:nvars
            for j=1:i
                aa=x(j);
                a=aa;
                aaa=a^2;
                b=aaa+b;
            end
        end
        F=b;
        %==================================================================
        %------------F9: Extended f10------------Fmin=0---------------------
    case 9
        a=0;
        for i=1:nvars-1
            aa=((x(i)^2+x(i+1)^2)^0.25)*((sin(50*((x(i)^2+x(i+1)^2)^0.1))^2+1));
            a=aa+a;
        end
        
        F=a+((x(nvars)^2+x(1)^2)^0.25)*((sin(50*((x(nvars)^2+x(1)^2)^0.1))^2+1));
        %==================================================================
        %------------F10: Bohachevsky ------------------------ Fmin=0 -----
    case 10
        a=0;
        for i=1:nvars-1
            aa=x(i)^2+2*x(i+1)^2-0.3*cos(3*pi*x(i))-0.4*cos(4*pi*x(i+1))+0.7;
            a=aa+a;
        end
        
        F=a;
        %==================================================================
        %------------ F11: Schaffer --------------------- Fmin=0 ----------
    case 11
        a=0;
        for i=1:nvars-1
            aa=((x(i)^2+x(i+1)^2)^0.25)*((sin(50*((x(i)^2+x(i+1)^2)^0.1))^2+1));
            a=aa+a;
        end
        
        F=a;
        %============F12: F9 and F1 combined ==============================
    case 12
        length1=ceil(nvars*0.25);
        length2=nvars-length1;
        b=0;
        for i=1:length1-1
            aa=((x(2*i)^2+x(2*i+2)^2)^0.25)*((sin(50*((x(2*i)^2+x(2*i+2)^2)^0.1))^2+1));
            b=aa+b;
        end
        b=b+((x(2)^2+x(2*i+2)^2)^0.25)*((sin(50*((x(2)^2+x(2*i+2)^2)^0.1))^2+1));
        a=0;
        for i=1:length2
            if i<=length1
                aa=(x(2*i-1)-o(2*i-1))^2;
                a=aa+a;
                j=2*i-1;
            else
                j=j+1;
                aa=(x(j)-o(j))^2;
                
                a=aa+a;
            end
        end
        F=b+a;   %   Fmin=0 Xmin=zeros(1, nvars) with zero shift
        %******************F13: F9 and F3 combined*********************************
    case 13
        length1=ceil(nvars*0.25);
        length2=nvars-length1;
        b=0;
        a=0;
        for i=1:length1-1
            aa=((x(2*i)^2+x(2*i+2)^2)^0.25)*((sin(50*((x(2*i)^2+x(2*i+2)^2)^0.1))^2+1));
            a=a+aa;
        end
        a=a+((x(2)^2+x(2*i+2)^2)^0.25)*((sin(50*((x(2)^2+x(2*i+2)^2)^0.1))^2+1));
        for i=1:length2-2
            if i<=length1-1
                aa=100*(x(2*i+1)-o(2*i+1)-(x(2*i-1)-o(2*i-1))^2)^2+(x(2*i-1)-o(2*i-1)-1)^2;
                b=b+aa;
            else
                j=length1+i+1;
                ab=100*(x(j+1)-o(j+1)-(x(j)-o(j))^2)^2+(x(j)-o(j)-1)^2;
                b=b+ab;
            end
        end
        F=b+a;   %  Fmin=0 Xmin=[1 0 1 0 1 0 1 0 1 1 1 1 1 1 1]; for 15 Variables with zero shift
        %*****************F14: Combination of F9 and F4****************************
    case 14
        length1=ceil(nvars*0.25);
        length2=nvars-length1;
        b=0;
        for i=1:length1-1
            aa=((x(2*i)^2+x(2*i+2)^2)^0.25)*((sin(50*((x(2*i)^2+x(2*i+2)^2)^0.1))^2+1));
            b=b+aa;
        end
        b=b+((x(2)^2+x(2*i+2)^2)^0.25)*((sin(50*((x(2)^2+x(2*i+2)^2)^0.1))^2+1));
        a=0;
        for i=1:length2-1
            if i<=length1
                aa=(x(2*i-1)-o(2*i-1))^2+10-10*cos(2*pi*(x(2*i-1)-o(2*i-1)));
                a=aa+a;
                j=2*i-1;
            else
                j=j+1;
                aa=(x(j)-o(j))^2+10-10*cos(2*pi*(x(j)-o(j)));
                a=aa+a;
            end
        end
        F=b+a;   % Fmin=0 x=zeros(1,10) with zero shift
        %********************F15 Combination of F10 and F7*************************
    case 15
        length1=ceil(nvars*0.25);
        length2=nvars-length1;
        b=0;
        for i=length1
            aa=x(2*i)^2+2*x(2*i+2)^2-0.3*cos(3*pi*x(2*i))-0.4*cos(4*pi*x(2*i+2))+0.7;
            b=aa+b;
        end
        
        a=0;
        b11=1;b12=1;
        a11=0;a12=0;
        for i=1:length2-1
            if i<=length1
                aa1=abs(x(2*i-1));
                a11=aa1+a11;
                b11=b11*aa1;
                a=a+a11+b11;
                j=2*i-1;
            else
                j=j+1;
                aa1=abs(x(j));
                a12=aa1+a12;
                b12=b12*aa1;
                a=a+a12+b12;
            end
        end
        F=b+a;   % Fmin=0 Xmin=zeros(1, nvars) with zero shift
        %********************F16 combination of F5 and F1**************************
    case 16
        length1=floor(nvars*0.5);
        length2=nvars-length1;
        b1=0; c=1;a=0;
        for i=length1
            b1=cos(x(2*i)/sqrt(2*i));
            c=c*b1;
            aa1=(1/4000)*x(2*i)^2;
            a=a+aa1;
        end
        b=a-c+1;
        a=0;
        for i=1:length2-1
            if i<=length1
                aa=(x(2*i-1)-o(2*i-1))^2;
                a=aa+a;
                j=2*i-1;
            else
                j=j+1;
                aa=(x(j)-o(j))^2;
                a=aa+a;
            end
        end
        F=b+a;   % Fmin=0, Xmin=zeros(1, nvars) with zero shift
        %********************F17 Combination of F3 and F4**************************
    case 17
        x=x-o; length1=floor(nvars*0.5);
        length2=nvars-length1;
        a=0;
        for i=length1-1
            aa=100*(x(2*i+2)-x(2*i)^2)^2+(x(2*i)-1)^2;
            a=aa+a;
        end
        b=0;
        for i=1:length2-1
            if i<=length1
                aa=x(2*i-1)^2+10-10*cos(2*pi*x(2*i-1));
                b=aa+b;
            else
                j=length1+i+1;
                aa=x(j)^2+10-10*cos(2*pi*x(j));
                b=aa+b;
            end
        end
        F=a+b;    % Fmin=0 Xmin=[0 1 0 1 0 1 0 1 0 1 0 1 0 1];  with zero shift
        %***************F18: Combination of F9 and F1******************************
    case 18
        length2=ceil(nvars*(1-0.75));
        length1=nvars-length2;
        a=0;
        for i=length2
            aa=(x(2*i-1)-o(2*i-1))^2;
            a=aa+a;
        end
        b=0;
        for i=1:length1-1
            if i<=length2
                
                aa=((x(2*i)^2+x(2*i+2)^2)^0.25)*((sin(50*((x(2*i)^2+x(2*i+2)^2)^0.1))^2+1));
                b=aa+b;j=2*i+2;
            else
                j=j+1;
                aa=((x(i)^2+x(i+1)^2)^0.25)*((sin(50*((x(i)^2+x(i+1)^2)^0.1))^2+1));
                b=aa+b;
            end
        end
        
        b=b+((x(1)^2+x(i+1)^2)^0.25)*((sin(50*((x(1)^2+x(i+1)^2)^0.1))^2+1));
        
        F=a+b;   % Fmin=0 Xmin=zeros(1, nvars) with zero shift
        %**************F19: Combination of F9 and F3*******************************
    case 19
        length2=ceil(nvars*(1-0.75));
        length1=nvars-length2;
        a=0;
        for i=length2
            aa=100*(x(2*i+1)-o(2*i+1)-(x(2*i-1)-o(2*i-1))^2)^2+(x(2*i-1)-o(2*i-1)-1)^2;
            a=aa+a;
        end
        b=0;
        for i=1:length1-2
            if i<=length2
                aa=((x(2*i)^2+x(2*i+2)^2)^0.25)*((sin(50*((x(2*i)^2+x(2*i+2)^2)^0.1))^2+1));
                b=aa+b;
                j=2*i+2;
            else
                aa=((x(j)^2+x(j+1)^2)^0.25)*((sin(50*((x(j)^2+x(j+1)^2)^0.1))^2+1));
                b=aa+b;j=j+1;
                
            end
        end
        b=b+((x(2)^2+x(end)^2)^0.25)*((sin(50*((x(2)^2+x(end)^2)^0.1))^2+1));
        F=a+b;
        % Fmin=0 Xmin=[1 0 1 0 1 0 1 0 1 0 0 0 0 0 0 0]
        % with zero shift
        %**************F20: Combination of F9 and F4*******************************
    case 20
        length2=ceil(nvars*(1-0.75));
        length1=nvars-length2;
        a=0;
        for i=length2
            aa=(x(2*i-1)-o(2*i-1))^2+10-10*cos(2*pi*(x(2*i-1)-o(2*i-1)));
            a=aa+a;
        end
        b=0;
        for i=1:length1-1
            if i<=length2
                aa=((x(i)^2+x(i+1)^2)^0.25)*((sin(50*((x(i)^2+x(i+1)^2)^0.1))^2+1));
                b=aa+b;j=i+1;
            else
                j=j+1;
                aa=((x(j)^2+x(j+1)^2)^0.25)*((sin(50*((x(j)^2+x(j+1)^2)^0.1))^2+1));
                b=aa+b;
            end
        end
        b=b+((x(1)^2+x(i+1)^2)^0.25)*((sin(50*((x(1)^2+x(i+1)^2)^0.1))^2+1));
        F=a+b;   % Fmin=0 Xmin=zeros(1, nvars) with zero shift
        %**************F21: Combination of F10 and F7******************************
    case 21
        length2=ceil(nvars*(1-0.75));
        length1=nvars-length2;
        a1=0;b1=1;
        for i=length2
            aa=abs(x(2*i-1));
            a1=aa+a1;
            b1=b1*aa;
        end
        a=a1+b1;
        b=0;
        for i=1:length1-1
            if i<=length2
                aa=x(i)^2+2*x(i+1)^2-0.3*cos(3*pi*x(i))-0.4*cos(4*pi*x(i+1))+0.7;
                b=aa+b;j=i+1;
            else
                j=j+1;
                aa=x(i)^2+2*x(i+1)^2-0.3*cos(3*pi*x(i))-0.4*cos(4*pi*x(i+1))+0.7;
                b=aa+b;
            end
        end
        F=a+b;   % Fmin=0 Xmin=zeros(1, nvars) with zero shift
end
end
