clear all;
clc;
close all;

global nvars LB UB hh o

A=[50,100,200,500,1000,5000,10000,50000,100000,200000,500000];    % Dimensions
a=30;            % Number of Independent runs
b=1;             % Starting dimension
c=1;             % Finishing dimension

%==========================================================================

for hh=1:21   % Number of benchmark Problems (F1-F21)
    switch hh
        case 1
            
            objective_function=@fun;
            disp('************Problem 1***********NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['*************************NNA*************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %--------- F1: Shifted Sphere --------------
                    o=randi([-100,100],1,nvars).*rand(1,nvars);
                    LB=ones(1,nvars)*-100;
                    UB=ones(1,nvars)*100;
                    
                    [Xmin,Fmin,NFEs,FMIN]=NNA(objective_function,LB,UB,nvars);
                    
                    figure;
                    plot(FMIN,'Linewidth',3);
                    legend('NNA');
                    title('F1');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    pause(0.1)
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                    
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');
                clear FF
            end
            
        case 2
            
            objective_function=@fun;
            disp('************Problem 2************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA**************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %--------- F2: Shifted Schwefel 2.21 ------------------
                    o=randi([-100,100],1,nvars).*rand(1,nvars);
                    LB=ones(1,nvars)*-100;
                    UB=ones(1,nvars)*100;
                                        
                    [Xmin,Fmin,NFEs,FMIN]=NNA(objective_function,LB,UB,nvars);
                    
                    plot(FMIN,'Linewidth',3)
                    pause(0.1)
                                        
                    legend('NNA');
                    
                    title('F2');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                    
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 3
            
            objective_function=@fun;
            disp('************Problem 3************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['*****************************NNA*********************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %--------- F3: Shifted Rosenbrock ---------------------
                    o=randi([-100,100],1,nvars).*rand(1,nvars);
                    LB=ones(1,nvars)*-100;
                    UB=ones(1,nvars)*100;
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F3');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 4
            
            objective_function=@fun;
            disp('************Problem 4************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['**************************NNA************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %--------- F4: Shifted Rastrigin ----------------------
                    LB=ones(1,nvars)*-5;
                    UB=ones(1,nvars)*5;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F4');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 5
            
            objective_function=@fun;
            disp('************Problem 5************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['*****************************NNA*********************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %--------- F5: Shifted Greiwank -----------------------
                    LB=ones(1,nvars)*-600;
                    UB=ones(1,nvars)*600;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F5');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 6
            
            objective_function=@fun;
            disp('************Problem 6************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['****************************NNA**********************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %--------- F6: Ackley (Shifted) -----------------------
                    LB=ones(1,nvars)*-32;
                    UB=ones(1,nvars)*32;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F6');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 7
            
            objective_function=@fun;
            disp('************Problem 7************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['*************************NNA************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %--------- F7: Schwefel 2.22 --------------------------
                    LB=ones(1,nvars)*-10;
                    UB=ones(1,nvars)*10;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F7');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 8
            
            objective_function=@fun;
            disp('************Problem 8***********NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['***************************NNA**********************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %--------- F8: Schwefel 1.2  --------------------------
                    LB=ones(1,nvars)*-65.536;
                    UB=ones(1,nvars)*65.536;
                    o=randi([-65,65],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F8');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 9
            
            objective_function=@fun;
            disp('************Problem 9************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['**************************NNA***********************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %--------- F9: Extended f10   -----------
                    LB=ones(1,nvars)*-100;
                    UB=ones(1,nvars)*100;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    hold off
                    
                    legend('NNA','NNA','GSA');
                    
                    title('F9');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 10
            
            objective_function=@fun;
            disp('************Problem 10************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['***************************NNA***********************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %--------- F10: Bohachevsky  -----------
                    LB=ones(1,nvars)*-15;
                    UB=ones(1,nvars)*15;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F10');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 11
            
            objective_function=@fun;
            disp('************Problem 11************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA**************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F11: Schaffer  -----------
                    LB=ones(1,nvars)*-100;
                    UB=ones(1,nvars)*100;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F11');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 12
            
            objective_function=@fun;
            disp('************Problem 12************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA**************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F12  -----------
                    LB=ones(1,nvars)*-100;
                    UB=ones(1,nvars)*100;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F12');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 13
            
            objective_function=@fun;
            disp('************Problem 13************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA**************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F13 -----------
                    LB=ones(1,nvars)*-100;
                    UB=ones(1,nvars)*100;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    title('F13');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 14
            
            objective_function=@fun;
            disp('************Problem 14************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA*************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F14  -----------
                    LB=ones(1,nvars)*-5;
                    UB=ones(1,nvars)*5;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F14');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 15
            objective_function=@fun;
            disp('************Problem 15***********NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA**************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F15 -----------
                    LB=ones(1,nvars)*-10;
                    UB=ones(1,nvars)*10;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F15');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 16
            
            objective_function=@fun;
            disp('************Problem 16************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA**************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F16   -----------
                    LB=ones(1,nvars)*-100;
                    UB=ones(1,nvars)*100;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F16');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 17
            
            objective_function=@fun;
            disp('************Problem 17************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA**************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F17 -----------
                    LB=ones(1,nvars)*-10;
                    UB=ones(1,nvars)*10;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F17');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 18
            
            objective_function=@fun;
            disp('************Problem 18************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA*************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F18 -----------
                    LB=ones(1,nvars)*-100;
                    UB=ones(1,nvars)*100;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F18');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 19
            
            objective_function=@fun;
            disp('************Problem 19************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA**************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F19  -----------
                    LB=ones(1,nvars)*-100;
                    UB=ones(1,nvars)*100;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F19');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 20
            
            objective_function=@fun;
            disp('************Problem 20************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA*************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F20  -----------
                    LB=ones(1,nvars)*-5;
                    UB=ones(1,nvars)*5;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F20');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
            
        case 21
            
            objective_function=@fun;
            disp('************Problem 21************NNA************************');
            for ii=b:c
                nvars=A(ii);
                disp(['************************NNA*************************',' nvars: ',num2str(nvars),' ** function: ',num2str(hh)]);
                mm=0;
                for k=1:a
                    %---------F21 -----------
                    LB=ones(1,nvars)*-10;
                    UB=ones(1,nvars)*10;
                    o=randi([LB(1),UB(1)],1,nvars).*rand(1,nvars);
                    
                    [Xmin,Fmin,NFEs]=NNA(objective_function,LB,UB,nvars);
                    
                    legend('NNA');
                    
                    title('F21');
                    xlabel('Number of Iterations','FontSize',24,'FontWeight','bold');
                    ylabel('Objective Function Value','FontSize',24,'FontWeight','bold');
                    
                    FF(k)=Fmin;
                    NFEss(k)=NFEs;
                    disp(['Run:  ',num2str(k),'   Error: ',num2str(Fmin),'   NFEs: ',num2str(NFEs)]);
                end
                
                Min_NFEs=min(NFEss)
                Ave_NFEs=mean(NFEss)
                Max_NFEs=max(NFEss)
                SD_NFEs=std(NFEss)
                
                Min=min(FF)
                Ave=mean(FF)
                Median=median(FF)
                Max=max(FF)
                SD=std(FF)
                CV=SD/Ave
                
                Results=[Min Ave Median Max SD CV Min_NFEs Ave_NFEs Max_NFEs SD_NFEs];
                
                if mm==0
                    heaNNAr={''  'Best Sol' 'Average Sol' 'Median Sol' 'Worse Sol' 'SD Sol' 'CV Sol' 'Best NFEs' 'Average NFEs' 'Worse NFEs' 'SD NFEs'};
                    mm=mm+1;
                end
                
                g='B';
                f=num2str(ii+1);
                f=strcat(g,f);
                xlswrite('NNA.xls',heaNNAr,hh);
                xlswrite('NNA.xls',Results,hh,f);
                FF=FF';
                xlswrite('NNA.xls',FF,hh,'B6');clear FF;
            end
    end
end
